# StartInstances

## 1. API Description

This API (StartInstances) is used to start one or more elastic compute instances.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">You can only perform this operation on instances whose status is</mark> <mark style="color:blue;">`STOPPED`</mark> <mark style="color:blue;">and that are not in the recycle bin.</mark>
* <mark style="color:blue;">If the API is called successfully, the instance status will become</mark> <mark style="color:blue;">`STARTING`</mark><mark style="color:blue;">. After the instance is started, its status will become</mark> <mark style="color:blue;">`RUNNING`</mark><mark style="color:blue;">.</mark>
* <mark style="color:blue;">This API is an async API. A response is returned after the request is sent. However, it does not mean the start has been completed. You can use</mark> <mark style="color:blue;">`DescribeInstancesStatus`</mark> <mark style="color:blue;">to query the status of the instance. If the status (instanceStatus) changes from</mark> <mark style="color:blue;">`STARTING`</mark> <mark style="color:blue;">to</mark> <mark style="color:blue;">`RUNNING`</mark><mark style="color:blue;">, it means that the instance has been started successfully. Any operations on the instances are not allowed while starting.</mark>
* <mark style="color:blue;">Batch operations are supported. The maximum number of instances in each request is 100.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                                                                                                                                                             |
| -------------- | -------- | --------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| instanceIds    | Yes      | Array of String | <p>Instance ID(s).</p><p>To obtain the instance ID, you can call DescribeInstances and look for instanceId in the response. The maximum number of instances in each request is 100.</p> |

## 3. Output Parameters

| Parameter Name | Type            | Description                                                                                                           |
| -------------- | --------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String          | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| instanceIds    | Array of String | A list of instance IDs that failed to start.                                                                          |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Start an instance of the specified ID.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: StartInstances
<Common Request Params>

Request:
{
  "instanceIds": [
    "instanceId1",
    "instanceId2"
  ]
}

Response:
{
  "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453",
  "response": {
    "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453",
    "instanceIds": ["xxx","xxx"]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).

| HTTP Status Code | Error Code                                 | Description                                                 |
| ---------------- | ------------------------------------------ | ----------------------------------------------------------- |
| 400              | OPERATION\_DENIED\_INSTANCE\_IN\_OPERATION | Instance is performing another operation.                   |
| 400              | UNSUPPORTED\_OPERATION\_INSTANCE\_STATUS   | Operations on instances in current state are not supported. |
